import { ReactNode } from 'react';

declare type IfProps = {
    when?: boolean;
    children?: ReactNode;
    render?: ReactNode;
    fallback?: ReactNode;
};
declare function If(props: IfProps): any;

declare type KeyType = string | number | symbol;
declare type HashView<T extends KeyType> = Record<T, ReactNode>;
declare type MapIfProps<T extends KeyType> = {
    rule: HashView<T>;
    value: T;
    fallback?: ReactNode;
};
declare function MapIf<T extends KeyType>(props: MapIfProps<T>): any;

declare type LoopProps<T> = {
    data?: T[];
    each: (item: T) => unknown;
    fallback?: ReactNode;
};
declare function Loop<T extends unknown>(props: LoopProps<T>): any;

export { If, IfProps, Loop, LoopProps, MapIf, MapIfProps };
